diff --git a/CMakeLists.txt b/CMakeLists.txt
index b30046547..6b9220d79 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -837,8 +837,8 @@ if( BUILD_VST2 )
       WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
       COMMAND echo "Packaging up VST2 component"
       COMMAND ./scripts/macOS/package-vst.sh   ${CMAKE_BINARY_DIR}/${CMAKE_BUILD_TYPE}/libsurge-vst2-dll.dylib ${SURGE_PRODUCT_DIR}
-      COMMAND codesign --force --sign - --timestamp=none ${SURGE_PRODUCT_DIR}/Surge.vst2/
-      COMMAND codesign -v ${SURGE_PRODUCT_DIR}/Surge.vst2/
+      COMMAND codesign --force --sign - --timestamp=none ${SURGE_PRODUCT_DIR}/Surge.vst/
+      COMMAND codesign -v ${SURGE_PRODUCT_DIR}/Surge.vst/
       )
    endif()
   if( UNIX AND NOT APPLE )
diff --git a/libs/filesystem/filesystem.cpp b/libs/filesystem/filesystem.cpp
index 96fb8676c..07b95e23d 100644
--- a/libs/filesystem/filesystem.cpp
+++ b/libs/filesystem/filesystem.cpp
@@ -55,6 +55,16 @@ namespace std { namespace experimental { namespace filesystem {
         path res(p.substr(idx));
         return res;
     }
+
+    path path::stem() {
+        auto idx = this->p.find_last_of("/");
+        auto q = this->p.substr(idx+1);
+        idx = q.find_last_of(".");
+        if( idx != std::string::npos )
+           q = q.substr( 0, idx );
+
+        return path( q );;
+    }
     // emd path class
 
     // file class:
diff --git a/libs/filesystem/filesystem.h b/libs/filesystem/filesystem.h
index a500f614d..063ed1a5d 100644
--- a/libs/filesystem/filesystem.h
+++ b/libs/filesystem/filesystem.h
@@ -43,7 +43,8 @@ namespace std { namespace experimental { namespace filesystem {
         std::string generic_string() const;
         
         path filename();
-        
+        path stem();
+       
         path extension();
     };
     
diff --git a/src/common/SurgeSynthesizer.cpp b/src/common/SurgeSynthesizer.cpp
index a3fece47c..0b84a30c3 100644
--- a/src/common/SurgeSynthesizer.cpp
+++ b/src/common/SurgeSynthesizer.cpp
@@ -51,6 +51,7 @@
 #include "SurgeParamConfig.h"
 
 #include "UserDefaults.h"
+#include "ImportFilesystem.h"
 
 using namespace std;
 
@@ -169,6 +170,8 @@ SurgeSynthesizer::SurgeSynthesizer(PluginLayer* parent, std::string suppliedData
    masterfade = 1.f;
    current_category_id = -1;
    patchid_queue = -1;
+   has_patchid_file = false;
+   patchid_file[0] = 0;
    patchid = -1;
    CC0 = 0;
    CC32 = 0;
@@ -2406,10 +2409,21 @@ DWORD WINAPI loadPatchInBackgroundThread(LPVOID lpParam)
    void* sy = lpParam;
 #endif
    SurgeSynthesizer* synth = (SurgeSynthesizer*)sy;
-   int patchid = synth->patchid_queue;
-   synth->patchid_queue = -1;
-   synth->allNotesOff();
-   synth->loadPatch(patchid);
+   if( synth->patchid_queue >= 0 )
+   {
+      int patchid = synth->patchid_queue;
+      synth->patchid_queue = -1;
+      synth->allNotesOff();
+      synth->loadPatch(patchid);
+   }
+   if( synth->has_patchid_file )
+   {
+      fs::path p(synth->patchid_file);
+      auto s = p.stem().generic_string();
+      synth->has_patchid_file = false;
+      synth->allNotesOff();
+      synth->loadPatchByPath( synth->patchid_file, -1, s.c_str() );
+   }
 #if TARGET_LV2
    synth->getParent()->patchChanged();
 #endif
@@ -2589,7 +2603,7 @@ void SurgeSynthesizer::process()
       clear_block(output[1], BLOCK_SIZE_QUAD);
       return;
    }
-   else if (patchid_queue >= 0)
+   else if (patchid_queue >= 0 || has_patchid_file)
    {
       masterfade = max(0.f, masterfade - 0.025f);
       mfade = masterfade * masterfade;
diff --git a/src/common/SurgeSynthesizer.h b/src/common/SurgeSynthesizer.h
index 7747a5901..4de377a6f 100644
--- a/src/common/SurgeSynthesizer.h
+++ b/src/common/SurgeSynthesizer.h
@@ -25,6 +25,7 @@ struct QuadFilterChainState;
 #include <list>
 #include <utility>
 #include <atomic>
+#include <cstdio>
 
 #if TARGET_AUDIOUNIT
 class aulayer;
@@ -190,6 +191,8 @@ class alignas(16) SurgeSynthesizer
    float refresh_ctrl_queue_value[8];
    bool process_input;
    int patchid_queue;
+   bool has_patchid_file;
+   char patchid_file[FILENAME_MAX];
 
    float vu_peak[8];
 
diff --git a/src/common/gui/CMenuAsSlider.cpp b/src/common/gui/CMenuAsSlider.cpp
index 90aea1d45..9affa3e50 100644
--- a/src/common/gui/CMenuAsSlider.cpp
+++ b/src/common/gui/CMenuAsSlider.cpp
@@ -13,8 +13,8 @@
 ** open source in September 2018.
 */
 
-#include "CMenuAsSlider.h"
 #include "SurgeGUIEditor.h"
+#include "CMenuAsSlider.h"
 #include "CScalableBitmap.h"
 #include <iostream>
 #include "DebugHelpers.h"
diff --git a/src/common/gui/CPatchBrowser.cpp b/src/common/gui/CPatchBrowser.cpp
index 76f8fd8c9..dbb82d85c 100644
--- a/src/common/gui/CPatchBrowser.cpp
+++ b/src/common/gui/CPatchBrowser.cpp
@@ -133,7 +133,40 @@ CMouseEventResult CPatchBrowser::onMouseDown(CPoint& where, const CButtonState&
    }
    
    contextMenu->addSeparator();
+
+   auto loadF = new CCommandMenuItem( CCommandMenuItem::Desc( Surge::UI::toOSCaseForMenu( "Load Patch From File..." ) ) );
+   loadF->setActions( [this](CCommandMenuItem *item) {
+                         Surge::UserInteractions::promptFileOpenDialog( "", "fxp", "Surge FXP Files",
+                                                                        [this](std::string fn) {
+                                                                           auto sge = dynamic_cast<SurgeGUIEditor*>(listener);
+                                                                           if( ! sge ) return;
+                                                                           sge->queuePatchFileLoad( fn );
+                                                                        });
+                      }
+      );
+   contextMenu->addEntry(loadF);
    
+   auto showU = new CCommandMenuItem( CCommandMenuItem::Desc( Surge::UI::toOSCaseForMenu( "Open User Patch Folder..." )));
+   showU->setActions( [this](CCommandMenuItem *item) {
+                         Surge::UserInteractions::openFolderInFileBrowser( this->storage->userDataPath );
+                      }
+      );
+   contextMenu->addEntry(showU);
+
+   auto showF = new CCommandMenuItem( CCommandMenuItem::Desc( Surge::UI::toOSCaseForMenu( "Open Factory Patch Folder..." )));
+   showF->setActions( [this](CCommandMenuItem *item) {
+                         Surge::UserInteractions::openFolderInFileBrowser( this->storage->datapath + "/patches_factory" );
+                      }
+      );
+   contextMenu->addEntry(showF);
+
+   auto show3 = new CCommandMenuItem( CCommandMenuItem::Desc( Surge::UI::toOSCaseForMenu( "Open Third Party Patch Folder..." )));
+   show3->setActions( [this](CCommandMenuItem *item) {
+                         Surge::UserInteractions::openFolderInFileBrowser( this->storage->datapath + "/patches_3rdparty" );
+                      }
+      );
+   contextMenu->addEntry(show3);
+
    auto refreshItem = new CCommandMenuItem(CCommandMenuItem::Desc(Surge::UI::toOSCaseForMenu("Refresh Patch List")));
    auto refreshAction = [this](CCommandMenuItem *item)
                            {
@@ -304,3 +337,42 @@ void CPatchBrowser::loadPatch(int id)
       listener->valueChanged(this);
    }
 }
+
+bool CPatchBrowser::onDrop(VSTGUI::DragEventData data )
+{
+   auto drag = data.drag;
+   auto where = data.pos;
+   uint32_t ct = drag->getCount();
+   if (ct == 1)
+   {
+      IDataPackage::Type t = drag->getDataType(0);
+      if (t == IDataPackage::kFilePath)
+      {
+         const void* fn;
+         drag->getData(0, fn, t);
+         const char* fName = static_cast<const char*>(fn);
+         fs::path fPath(fName);
+         if ((_stricmp(fPath.extension().generic_string().c_str(), ".fxp") != 0) )
+         {
+            Surge::UserInteractions::promptError(
+               std::string( "Surge only supports drag-and-drop of .fxp files onto the Patch Browser. " ) +
+               "You dropped a file with extension " + fPath.extension().generic_string(),
+               "Please drag a valid file type!");
+         }
+         else
+         {
+            auto sge = dynamic_cast<SurgeGUIEditor*>(listener);
+            if( ! sge ) return false;
+            sge->queuePatchFileLoad( fName );
+         }
+      }
+      else
+      {
+         Surge::UserInteractions::promptError(
+             "Surge only supports drag-and-drop of files onto the Patch Browser.",
+             "Please drop a file!");
+      }
+   }
+
+   return true;
+}
diff --git a/src/common/gui/CPatchBrowser.h b/src/common/gui/CPatchBrowser.h
index b420c0e95..afa5bc550 100644
--- a/src/common/gui/CPatchBrowser.h
+++ b/src/common/gui/CPatchBrowser.h
@@ -18,7 +18,7 @@
 #include "SurgeStorage.h"
 #include "SkinSupport.h"
 
-class CPatchBrowser : public VSTGUI::CControl, public Surge::UI::SkinConsumingComponnt
+class CPatchBrowser : public VSTGUI::CControl, public VSTGUI::IDropTarget, public Surge::UI::SkinConsumingComponnt
 {
 public:
 
@@ -67,6 +67,21 @@ class CPatchBrowser : public VSTGUI::CControl, public Surge::UI::SkinConsumingCo
       setDirty(true);
    }
 
+   virtual VSTGUI::DragOperation onDragEnter(VSTGUI::DragEventData data) override {
+      return VSTGUI::DragOperation::Copy;
+   }
+   virtual VSTGUI::DragOperation onDragMove(VSTGUI::DragEventData data) override
+   {
+       return VSTGUI::DragOperation::Copy;
+   }
+   virtual void onDragLeave(VSTGUI::DragEventData data) override
+   {
+   }
+
+   virtual bool onDrop(VSTGUI::DragEventData data) override;
+
+   virtual VSTGUI::SharedPointer<VSTGUI::IDropTarget> getDropTarget () override { return this; }
+
    virtual void draw(VSTGUI::CDrawContext* dc) override;
    VSTGUI::CMouseEventResult onMouseDown(VSTGUI::CPoint& where, const VSTGUI::CButtonState& button) override;
    void loadPatch(int id);
diff --git a/src/common/gui/CSnapshotMenu.cpp b/src/common/gui/CSnapshotMenu.cpp
index 34cccea70..7ed068b31 100644
--- a/src/common/gui/CSnapshotMenu.cpp
+++ b/src/common/gui/CSnapshotMenu.cpp
@@ -453,58 +453,79 @@ void CFxMenu::rescanUserPresets()
 
    auto ud = storage->userFXPath;
 
-   if( fs::is_directory( fs::path( ud ) ) ) {
-      for( auto &d : fs::directory_iterator( fs::path( ud ) ) )
+   std::vector< fs::path > sfxfiles;
+
+   std::deque<fs::path> workStack;
+   workStack.push_back(fs::path(ud));
+   while (!workStack.empty())
+   {
+      auto top = workStack.front();
+      workStack.pop_front();
+      if( fs::is_directory(top) )
       {
-         auto fn = d.path().generic_string();
-         std::string ending = ".srgfx";
-         if( fn.length() >= ending.length() && ( 0 == fn.compare( fn.length() - ending.length(), ending.length(), ending ) ) )
+         for (auto& d : fs::directory_iterator(top))
          {
-            UserPreset preset;
-            preset.file = fn;
-            TiXmlDocument d;
-            int t;
-
-            if( ! d.LoadFile( fn ) ) goto badPreset;
-
-            auto r = TINYXML_SAFE_TO_ELEMENT(d.FirstChild( "single-fx" ) );
-            if( ! r ) goto badPreset;
-
-            auto s = TINYXML_SAFE_TO_ELEMENT(r->FirstChild( "snapshot" ) );
-            if( ! s ) goto badPreset;
-
-            if( ! s->Attribute( "name" ) ) goto badPreset;
-            preset.name = s->Attribute( "name" );
+            if (fs::is_directory(d))
+            {
+               workStack.push_back(d);
+            }
+            else if( d.path().extension().generic_string() == ".srgfx" )
+            {
+               sfxfiles.push_back( d.path() );
+            }
+         }
+      }
+   }
 
-            if( s->QueryIntAttribute( "type", &t ) != TIXML_SUCCESS ) goto badPreset;
-            preset.type = t;
+   for( auto f : sfxfiles )
+   {
+      auto fn = f.generic_string();
 
-            for( int i=0; i<n_fx_params; ++i )
+      {
+         UserPreset preset;
+         preset.file = fn;
+         TiXmlDocument d;
+         int t;
+         
+         if( ! d.LoadFile( fn ) ) goto badPreset;
+         
+         auto r = TINYXML_SAFE_TO_ELEMENT(d.FirstChild( "single-fx" ) );
+         if( ! r ) goto badPreset;
+         
+         auto s = TINYXML_SAFE_TO_ELEMENT(r->FirstChild( "snapshot" ) );
+         if( ! s ) goto badPreset;
+         
+         if( ! s->Attribute( "name" ) ) goto badPreset;
+         preset.name = s->Attribute( "name" );
+         
+         if( s->QueryIntAttribute( "type", &t ) != TIXML_SUCCESS ) goto badPreset;
+         preset.type = t;
+         
+         for( int i=0; i<n_fx_params; ++i )
+         {
+            double fl;
+            std::string p = "p";
+            if( s->QueryDoubleAttribute( (p + std::to_string(i)).c_str(), &fl ) == TIXML_SUCCESS )
             {
-               double fl;
-               std::string p = "p";
-               if( s->QueryDoubleAttribute( (p + std::to_string(i)).c_str(), &fl ) == TIXML_SUCCESS )
-               {
-                  preset.p[i] = fl;
-               }
-               if( s->QueryDoubleAttribute( (p + std::to_string(i) + "_temposync" ).c_str(), &fl ) == TIXML_SUCCESS && fl != 0 )
-               {
-                  preset.ts[i] = true;
-               }
-               if( s->QueryDoubleAttribute( (p + std::to_string(i) + "_extend_range").c_str(), &fl ) == TIXML_SUCCESS && fl != 0 )
-               {
-                  preset.er[i] = fl;
-               }
+               preset.p[i] = fl;
+            }
+            if( s->QueryDoubleAttribute( (p + std::to_string(i) + "_temposync" ).c_str(), &fl ) == TIXML_SUCCESS && fl != 0 )
+            {
+               preset.ts[i] = true;
+            }
+            if( s->QueryDoubleAttribute( (p + std::to_string(i) + "_extend_range").c_str(), &fl ) == TIXML_SUCCESS && fl != 0 )
+            {
+               preset.er[i] = fl;
             }
-            if( userPresets.find(preset.type) == userPresets.end() )
-               userPresets[preset.type] = std::vector<UserPreset>();
-            userPresets[preset.type].push_back(preset);
          }
-      badPreset:
-         ;
+         if( userPresets.find(preset.type) == userPresets.end() )
+            userPresets[preset.type] = std::vector<UserPreset>();
+         userPresets[preset.type].push_back(preset);
       }
+   badPreset:
+            ;
    }
-
+   
    for( auto &a : userPresets )
       std::sort( a.second.begin(), a.second.end(),
                  [](UserPreset a, UserPreset b)
@@ -689,18 +710,20 @@ void CFxMenu::saveFX()
       return;
    }
 
-   std::string pn = storage->userFXPath;
-   fs::create_directories( pn );
 
+   int ti = fx->type.val.i;
+   
    std::ostringstream oss;
-   oss << pn
+   oss << storage->userFXPath
 #if WINDOWS
-        << "\\"
+       << "\\" << fxtype_names[ti] << "\\";
 #else
-        << "/"
+       << "/" << fxtype_names[ti] << "/";
 #endif
-       << fxName << ".srgfx";
-   auto fn = oss.str();
+   auto pn = oss.str();
+   fs::create_directories( pn );
+
+   auto fn = pn + fxName + ".srgfx";
    std::ofstream pfile( fn, std::ios::out );
    if( ! pfile.is_open() )
    {
diff --git a/src/common/gui/SurgeGUIEditor.h b/src/common/gui/SurgeGUIEditor.h
index 434197b2c..4fb9da965 100644
--- a/src/common/gui/SurgeGUIEditor.h
+++ b/src/common/gui/SurgeGUIEditor.h
@@ -253,6 +253,12 @@ class SurgeGUIEditor : public EditorType, public VSTGUI::IControlListener, publi
                           std::function<void()> onClose = [](){} );
 
    std::string getDisplayForTag( long tag );
+
+   void queuePatchFileLoad( std::string file )
+      {
+         strncpy( synth->patchid_file, file.c_str(), FILENAME_MAX );
+         synth->has_patchid_file = true;
+      }
    
 private:
    int wsx = BASE_WINDOW_SIZE_X;
